[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

# 24. The GDB/MI Interface

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## Function and Purpose

GDB/MI is a line based machine oriented text interface to GDB and is activated by specifying using the ``--interpreter'` command line option (see section 2.1.2 Choosing Modes). It is specifically intended to support the development of systems which use the debugger as just one small component of a larger system.

This chapter is a specification of the GDB/MI interface. It is written in the form of a reference manual.

Note that GDB/MI is still under construction, so some of the features described below are incomplete and subject to change (see section GDB/MI Development and Front Ends).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## Notation and Terminology

This chapter uses the following notation:

- `|` separates two alternatives.

- `[ something ]` indicates that something is optional: it may or may not be given.

- `( group )*` means that group inside the parentheses may repeat zero or more times.

- `( group )+` means that group inside the parentheses may repeat one or more times.

- `"string"` means a literal string.

> 24.1 GDB/MI Command Syntax |  |
> 24.2 GDB/MI Compatibility with CLI |  |
> 24.3 GDB/MI Development and Front Ends |  |
> 24.4 GDB/MI Output Records |  |
> 24.5 Simple Examples of GDB/MI Interaction |  |
> 24.6 GDB/MI Command Description Format |  |
> 24.7 GDB/MI Breakpoint Commands |  |
> 24.8 GDB/MI Program Context |  |
> 24.9 GDB/MI Thread Commands |  |
> 24.10 GDB/MI Program Execution |  |
> 24.11 GDB/MI Stack Manipulation Commands |  |
> 24.12 GDB/MI Variable Objects |  |
> 24.13 GDB/MI Data Manipulation |  |
> 24.14 GDB/MI Tracepoint Commands |  |
> 24.15 GDB/MI Symbol Query Commands |  |
> 24.16 GDB/MI File Commands |  |
> 24.17 GDB/MI Target Manipulation Commands |  |
> 24.18 GDB/MI File Transfer Commands |  |
> 24.19 Miscellaneous GDB/MI Commands |  |

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.1 GDB/MI Command Syntax

> 24.1.1 GDB/MI Input Syntax |  |
> 24.1.2 GDB/MI Output Syntax |  |

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 24.1.1 GDB/MI Input Syntax

`command ==>`
  `cli-command | mi-command`

`cli-command ==>`
  `[ token ] cli-command nl`, where cli-command is any existing GDB CLI command.

`mi-command ==>`
  `[ token ] "-" operation ( " " option )* `[` " --" `]` ( " " parameter )* nl`

`token ==>`
  "any sequence of digits"

`option ==>`
  `"-" parameter [ " " parameter ]`

`parameter ==>`
  `non-blank-sequence | c-string`

`operation ==>`
  any of the operations described in this chapter

`non-blank-sequence ==>`
  anything, provided it doesn't contain special characters such as "-", nl, """ and of course " "

`c-string ==>`
  `""" seven-bit-iso-c-string-content """`

`nl ==>`
  `CR | CR-LF`

Notes:

- The CLI commands are still handled by the MI interpreter; their output is described below.

- The `token`, when present, is passed back when the command finishes.

- Some MI commands accept optional arguments as part of the parameter list. Each option is identified by a leading ``-'` (dash) and may be followed by an optional argument parameter. Options occur first in the parameter list and can be delimited from normal parameters using ``--'` (this is useful when some parameters begin with a dash).

Pragmatics:

- We want easy access to the existing CLI syntax (for debugging).

- We want it to be easy to spot a MI operation.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 24.1.2 GDB/MI Output Syntax

The output from GDB/MI consists of zero or more out-of-band records followed, optionally, by a single result record. This result record is for the most recent command. The sequence of output records is terminated by ``(gdb)'`.

If an input command was prefixed with a `token` then the corresponding output for that command will also be prefixed by that same token.

`output ==>`
  `( out-of-band-record )* [ result-record ] "(gdb)" nl`

`result-record ==>`
  `[ token ] "^" result-class ( "," result )* nl`

`out-of-band-record ==>`
  `async-record | stream-record`

`async-record ==>`
  `exec-async-output | status-async-output | notify-async-output`

`exec-async-output ==>`
  `[ token ] "*" async-output`

`status-async-output ==>`
  `[ token ] "+" async-output`

`notify-async-output ==>`
  `[ token ] "=" async-output`

`async-output ==>`
  `async-class ( "," result )* nl`

`result-class ==>`
  `"done" | "running" | "connected" | "error" | "exit"`

`async-class ==>`
  `"stopped" | others` (where others will be added depending on the needs--this is still in development).

`result ==>`
  `variable "=" value`

`variable ==>`
  `string`

`value ==>`
  `const | tuple | list`

`const ==>`
  `c-string`

`tuple ==>`
  `"{}" | "{" result ( "," result )* "}"`

`list ==>`
  `"[]" | "[" value ( "," value )* "]" | "[" result ( "," result )* "]"`

`stream-record ==>`
  `console-stream-output | target-stream-output | log-stream-output`

`console-stream-output ==>`
  `"~" c-string`

`target-stream-output ==>`
  `"@" c-string`

`log-stream-output ==>`
  `"&" c-string`

`nl ==>`
  `CR | CR-LF`

`token ==>`
  any sequence of digits.

Notes:

- All output sequences end in a single line containing a period.

- The `token` is from the corresponding request. If an execution command is interrupted by the ``-exec-interrupt'` command, the token associated with the ``*stopped'` message is the one of the original execution command, not the one of the interrupt command.

- status-async-output contains on-going status information about the progress of a slow operation. It can be discarded. All status output is prefixed by ``+'`.

- exec-async-output contains asynchronous state change on the target (stopped, started, disappeared). All async output is prefixed by ``*'`.

- notify-async-output contains supplementary information that the client should handle (e.g., a new breakpoint information). All notify output is prefixed by ``='`.

- console-stream-output is output that should be displayed as is in the console. It is the textual response to a CLI command. All the console output is prefixed by ``~'`.

- target-stream-output is the output produced by the target program. All the target output is prefixed by ``@'`.

- log-stream-output is output text coming from GDB's internals, for instance messages that should be displayed as part of an error log. All the log output is prefixed by ``&'`.

- New GDB/MI commands should only output lists containing values.

See section GDB/MI Stream Records, for more details about the various output records.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.2 GDB/MI Compatibility with CLI

For the developers convenience CLI commands can be entered directly, but there may be some unexpected behaviour. For example, commands that query the user will behave as if the user replied yes, breakpoint command lists are not executed and some CLI commands, such as `if`, `when` and `define`, prompt for further input with ``>'`, which is not valid MI output.

This feature may be removed at some stage in the future and it is recommended that front ends use the `-interpreter-exec` command (see -interpreter-exec).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.3 GDB/MI Development and Front Ends

The application which takes the MI output and presents the state of the program being debugged to the user is called a front end.

Although GDB/MI is still incomplete, it is currently being used by a variety of front ends to GDB. This makes it difficult to introduce new functionality without breaking existing usage. This section tries to minimize the problems by describing how the protocol might change.

Some changes in MI need not break a carefully designed front end, and for these the MI version will remain unchanged. The following is a list of changes that may occur within one level, so front ends should parse MI output in a way that can handle them:

- New MI commands may be added.

- New fields may be added to the output of any MI command.

- The range of values for fields with specified values, e.g., `in_scope` (see -var-update) may be extended.

If the changes are likely to break front ends, the MI version level will be increased by one. This will allow the front end to parse the output according to the MI version. Apart from mi0, new versions of GDB will not support old versions of MI and it will be the responsibility of the front end to work with the new one.

The best way to avoid unexpected changes in MI that might break your front end is to make your project known to GDB developers and follow development on gdb@sourceware.org and gdb-patches@sourceware.org. There is also the mailing list dmi-discuss@lists.freestandards.org, hosted by the Free Standards Group, which has the aim of creating a more general MI protocol called Debugger Machine Interface (DMI) that will become a standard for all debuggers, not just GDB.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.4 GDB/MI Output Records

> 24.4.1 GDB/MI Result Records |  |
> 24.4.2 GDB/MI Stream Records |  |
> 24.4.3 GDB/MI Out-of-band Records |  |

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 24.4.1 GDB/MI Result Records

In addition to a number of out-of-band notifications, the response to a GDB/MI command includes one of the following result indications:

`"^done" [ "," results ]`
  The synchronous operation was successful, `results` are the return values.

`"^running"`
  The asynchronous operation was successfully started. The target is running.

`"^connected"`
  GDB has connected to a remote target.

`"^error" "," c-string`
  The operation failed. The `c-string` contains the corresponding error message.

`"^exit"`
  GDB has terminated.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 24.4.2 GDB/MI Stream Records

GDB internally maintains a number of output streams: the console, the target, and the log. The output intended for each of these streams is funneled through the GDB/MI interface using stream records.

Each stream record begins with a unique prefix character which identifies its stream (see section GDB/MI Output Syntax). In addition to the prefix, each stream record contains a `string-output`. This is either raw text (with an implicit new line) or a quoted C string (which does not contain an implicit newline).

`"~" string-output`
  The console output stream contains text that should be displayed in the CLI console window. It contains the textual responses to CLI commands.

`"@" string-output`
  The target output stream contains any textual output from the running target. This is only present when GDB's event loop is truly asynchronous, which is currently only the case for remote targets.

`"&" string-output`
  The log stream contains debugging messages being produced by GDB's internals.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

### 24.4.3 GDB/MI Out-of-band Records

Out-of-band records are used to notify the GDB/MI client of additional changes that have occurred. Those changes can either be a consequence of GDB/MI (e.g., a breakpoint modified) or a result of target activity (e.g., target stopped).

The following is a preliminary list of possible out-of-band records. In particular, the exec-async-output records.

`*stopped,reason="reason"`

reason can be one of the following:

`breakpoint-hit`
  A breakpoint was reached.
`watchpoint-trigger`
  A watchpoint was triggered.
`read-watchpoint-trigger`
  A read watchpoint was triggered.
`access-watchpoint-trigger`
  An access watchpoint was triggered.
`function-finished`
  An -exec-finish or similar CLI command was accomplished.
`location-reached`
  An -exec-until or similar CLI command was accomplished.
`watchpoint-scope`
  A watchpoint has gone out of scope.
`end-stepping-range`
  An -exec-next, -exec-next-instruction, -exec-step, -exec-step-instruction or similar CLI command was accomplished.
`exited-signalled`
  The inferior exited because of a signal.
`exited`
  The inferior exited.
`exited-normally`
  The inferior exited normally.
`signal-received`
  A signal was received by the inferior.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.5 Simple Examples of GDB/MI Interaction

This subsection presents several simple examples of interaction using the GDB/MI interface. In these examples, ``->'` means that the following line is passed to GDB/MI as input, while ``<-'` means the output received from GDB/MI.

Note the line breaks shown in the examples are here only for readability, they don't appear in the real output.

### Setting a Breakpoint

Setting a breakpoint generates synchronous output which contains detailed information of the breakpoint.

    -> -break-insert main
    <- ^done,bkpt={number="1",type="breakpoint",disp="keep",
        enabled="y",addr="0x08048564",func="main",file="myprog.c",
        fullname="/home/nickrob/myprog.c",line="68",times="0"}
    <- (gdb)

### Program Execution

Program execution generates asynchronous records and MI gives the reason that execution stopped.

    -> -exec-run
    <- ^running
    <- (gdb)
    <- *stopped,reason="breakpoint-hit",bkptno="1",thread-id="0",
       frame={addr="0x08048564",func="main",
       args=[{name="argc",value="1"},{name="argv",value="0xbfc4d4d4"}],
       file="myprog.c",fullname="/home/nickrob/myprog.c",line="68"}
    <- (gdb)
    -> -exec-continue
    <- ^running
    <- (gdb)
    <- *stopped,reason="exited-normally"
    <- (gdb)

### Quitting GDB

Quitting GDB just prints the result class ``^exit'`.

    -> (gdb)
    <- -gdb-exit
    <- ^exit

### A Bad Command

Here's what happens if you pass a non-existent command:

    -> -rubbish
    <- ^error,msg="Undefined MI command: rubbish"
    <- (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.6 GDB/MI Command Description Format

The remaining sections describe blocks of commands. Each block of commands is laid out in a fashion similar to this section.

### Motivation

The motivation for this collection of commands.

### Introduction

A brief introduction to this collection of commands as a whole.

### Commands

For each command in the block, the following is described:

#### Synopsis

     -command args...

#### Result

#### GDB Command

The corresponding GDB CLI command(s), if any.

#### Example

Example(s) formatted for readability. Some of the described commands have not been implemented yet and these are labeled N.A. (not available).

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.7 GDB/MI Breakpoint Commands

This section documents GDB/MI commands for manipulating breakpoints.

### The `-break-after` Command

#### Synopsis

     -break-after number count

The breakpoint number number is not in effect until it has been hit count times. To see how this is reflected in the output of the ``-break-list'` command, see the description of the ``-break-list'` command below.

#### GDB Command

The corresponding GDB command is ``ignore'`.

#### Example

    (gdb)
    -break-insert main
    ^done,bkpt={number="1",addr="0x000100d0",file="hello.c",
    fullname="/home/foo/hello.c",line="5",times="0"}
    (gdb)
    -break-after 1 3
    ~
    ^done
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="1",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x000100d0",func="main",file="hello.c",fullname="/home/foo/hello.c",
    line="5",times="0",ignore="3"}]}
    (gdb)

### The `-break-condition` Command

#### Synopsis

     -break-condition number expr

Breakpoint number will stop the program only if the condition in expr is true. The condition becomes part of the ``-break-list'` output (see the description of the ``-break-list'` command below).

#### GDB Command

The corresponding GDB command is ``condition'`.

#### Example

    (gdb)
    -break-condition 1 1
    ^done
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="1",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x000100d0",func="main",file="hello.c",fullname="/home/foo/hello.c",
    line="5",cond="1",times="0",ignore="3"}]}
    (gdb)

### The `-break-delete` Command

#### Synopsis

     -break-delete ( breakpoint )+

Delete the breakpoint(s) whose number(s) are specified in the argument list. This is obviously reflected in the breakpoint list.

#### GDB Command

The corresponding GDB command is ``delete'`.

#### Example

    (gdb)
    -break-delete 1
    ^done
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="0",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[]}
    (gdb)

### The `-break-disable` Command

#### Synopsis

     -break-disable ( breakpoint )+

Disable the named breakpoint(s). The field ``enabled'` in the break list is now set to ``n'` for the named breakpoint(s).

#### GDB Command

The corresponding GDB command is ``disable'`.

#### Example

    (gdb)
    -break-disable 2
    ^done
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="1",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="2",type="breakpoint",disp="keep",enabled="n",
    addr="0x000100d0",func="main",file="hello.c",fullname="/home/foo/hello.c",
    line="5",times="0"}]}
    (gdb)

### The `-break-enable` Command

#### Synopsis

     -break-enable ( breakpoint )+

Enable (previously disabled) breakpoint(s).

#### GDB Command

The corresponding GDB command is ``enable'`.

#### Example

    (gdb)
    -break-enable 2
    ^done
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="1",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="2",type="breakpoint",disp="keep",enabled="y",
    addr="0x000100d0",func="main",file="hello.c",fullname="/home/foo/hello.c",
    line="5",times="0"}]}
    (gdb)

### The `-break-info` Command

#### Synopsis

     -break-info breakpoint

Get information about a single breakpoint.

#### GDB Command

The corresponding GDB command is ``info break breakpoint'`.

#### Example

N.A.

### The `-break-insert` Command

#### Synopsis

     -break-insert [ -t ] [ -h ] [ -f ]
        [ -c condition ] [ -i ignore-count ]
        [ -p thread ] [ location ]

If specified, location, can be one of:

- function
- filename:linenum
- filename:function
- *address

The possible optional parameters of this command are:

``-t'`
  Insert a temporary breakpoint.
``-h'`
  Insert a hardware breakpoint.
``-c condition'`
  Make the breakpoint conditional on condition.
``-i ignore-count'`
  Initialize the ignore-count.
``-f'`
  If location cannot be parsed (for example if it refers to unknown files or functions), create a pending breakpoint. Without this flag, GDB will report an error, and won't create a breakpoint, if location cannot be parsed.

#### Result

The result is in the form:

    ^done,bkpt={number="number",type="type",disp="del"|"keep",
    enabled="y"|"n",addr="hex",func="funcname",file="filename",
    fullname="full_filename",line="lineno",[thread="threadno,]
    times="times"}

where number is the GDB number for this breakpoint, funcname is the name of the function where the breakpoint was inserted, filename is the name of the source file which contains this function, lineno is the source line number within that file and times the number of times that the breakpoint has been hit (always 0 for -break-insert but may be greater for -break-info or -break-list which use the same output).

Note: this format is open to change.

#### GDB Command

The corresponding GDB commands are ``break'`, ``tbreak'`, ``hbreak'`, ``thbreak'`, and ``rbreak'`.

#### Example

    (gdb)
    -break-insert main
    ^done,bkpt={number="1",addr="0x0001072c",file="recursive2.c",
    fullname="/home/foo/recursive2.c,line="4",times="0"}
    (gdb)
    -break-insert -t foo
    ^done,bkpt={number="2",addr="0x00010774",file="recursive2.c",
    fullname="/home/foo/recursive2.c,line="11",times="0"}
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="2",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x0001072c", func="main",file="recursive2.c",
    fullname="/home/foo/recursive2.c,"line="4",times="0"},
    bkpt={number="2",type="breakpoint",disp="del",enabled="y",
    addr="0x00010774",func="foo",file="recursive2.c",
    fullname="/home/foo/recursive2.c",line="11",times="0"}]}
    (gdb)
    -break-insert -r foo.*
    ~int foo(int, int);
    ^done,bkpt={number="3",addr="0x00010774",file="recursive2.c,
    "fullname="/home/foo/recursive2.c",line="11",times="0"}
    (gdb)

### The `-break-list` Command

#### Synopsis

     -break-list

Displays the list of inserted breakpoints, showing the following fields:

``Number'`
  number of the breakpoint
``Type'`
  type of the breakpoint: ``breakpoint'` or ``watchpoint'`
``Disposition'`
  should the breakpoint be deleted or disabled when it is hit: ``keep'` or ``nokeep'`
``Enabled'`
  is the breakpoint enabled or no: ``y'` or ``n'`
``Address'`
  memory location at which the breakpoint is set
``What'`
  logical location of the breakpoint, expressed by function name, file name, line number
``Times'`
  number of times the breakpoint has been hit

If there are no breakpoints or watchpoints, the `BreakpointTable` `body` field is an empty list.

#### GDB Command

The corresponding GDB command is ``info break'`.

#### Example

    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="2",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x000100d0",func="main",file="hello.c",line="5",times="0"},
    bkpt={number="2",type="breakpoint",disp="keep",enabled="y",
    addr="0x00010114",func="foo",file="hello.c",fullname="/home/foo/hello.c",
    line="13",times="0"}]}
    (gdb)

Here's an example of the result when there are no breakpoints:

    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="0",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[]}
    (gdb)

### The `-break-watch` Command

#### Synopsis

     -break-watch [ -a | -r ]

Create a watchpoint. With the ``-a'` option it will create an access watchpoint, i.e., a watchpoint that triggers either on a read from or on a write to the memory location. With the ``-r'` option, the watchpoint created is a read watchpoint, i.e., it will trigger only when the memory location is accessed for reading. Without either of the options, the watchpoint created is a regular watchpoint, i.e., it will trigger when the memory location is accessed for writing. See section Setting Watchpoints.

Note that ``-break-list'` will report a single list of watchpoints and breakpoints inserted.

#### GDB Command

The corresponding GDB commands are ``watch'`, ``awatch'`, and ``rwatch'`.

#### Example

Setting a watchpoint on a variable in the `main` function:

    (gdb)
    -break-watch x
    ^done,wpt={number="2",exp="x"}
    (gdb)
    -exec-continue
    ^running
    (gdb)
    *stopped,reason="watchpoint-trigger",wpt={number="2",exp="x"},
    value={old="-268439212",new="55"},
    frame={func="main",args=[],file="recursive2.c",
    fullname="/home/foo/bar/recursive2.c",line="5"}
    (gdb)

Setting a watchpoint on a variable local to a function. GDB will stop the program execution twice: first for the variable changing value, then for the watchpoint going out of scope.

    (gdb)
    -break-watch C
    ^done,wpt={number="5",exp="C"}
    (gdb)
    -exec-continue
    ^running
    (gdb)
    *stopped,reason="watchpoint-trigger",
    wpt={number="5",exp="C"},value={old="-276895068",new="3"},
    frame={func="callee4",args=[],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="13"}
    (gdb)
    -exec-continue
    ^running
    (gdb)
    *stopped,reason="watchpoint-scope",wpnum="5",
    frame={func="callee3",args=[{name="strarg",
    value="0x11940 \"A string argument.\""}],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="18"}
    (gdb)

Listing breakpoints and watchpoints, at different points in the program execution. Note that once the watchpoint goes out of scope, it is deleted.

    (gdb)
    -break-watch C
    ^done,wpt={number="2",exp="C"}
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="2",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x00010734",func="callee4",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/devo/gdb/testsuite/gdb.mi/basics.c"line="8",times="1"},
    bkpt={number="2",type="watchpoint",disp="keep",
    enabled="y",addr="",what="C",times="0"}]}
    (gdb)
    -exec-continue
    ^running
    (gdb)
    *stopped,reason="watchpoint-trigger",wpt={number="2",exp="C"},
    value={old="-276895068",new="3"},
    frame={func="callee4",args=[],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="13"}
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="2",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x00010734",func="callee4",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/devo/gdb/testsuite/gdb.mi/basics.c",line="8",times="1"},
    bkpt={number="2",type="watchpoint",disp="keep",
    enabled="y",addr="",what="C",times="-5"}]}
    (gdb)
    -exec-continue
    ^running
    ^done,reason="watchpoint-scope",wpnum="2",
    frame={func="callee3",args=[{name="strarg",
    value="0x11940 \"A string argument.\""}],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="18"}
    (gdb)
    -break-list
    ^done,BreakpointTable={nr_rows="1",nr_cols="6",
    hdr=[{width="3",alignment="-1",col_name="number",colhdr="Num"},
    {width="14",alignment="-1",col_name="type",colhdr="Type"},
    {width="4",alignment="-1",col_name="disp",colhdr="Disp"},
    {width="3",alignment="-1",col_name="enabled",colhdr="Enb"},
    {width="10",alignment="-1",col_name="addr",colhdr="Address"},
    {width="40",alignment="2",col_name="what",colhdr="What"}],
    body=[bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x00010734",func="callee4",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/devo/gdb/testsuite/gdb.mi/basics.c",line="8",
    times="1"}]}
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.8 GDB/MI Program Context

### The `-exec-arguments` Command

#### Synopsis

     -exec-arguments args

Set the inferior program arguments, to be used in the next ``-exec-run'`.

#### GDB Command

The corresponding GDB command is ``set args'`.

#### Example

Don't have one around.

### The `-exec-show-arguments` Command

#### Synopsis

     -exec-show-arguments

Print the arguments of the program.

#### GDB Command

The corresponding GDB command is ``show args'`.

#### Example

N.A.

### The `-environment-cd` Command

#### Synopsis

     -environment-cd pathdir

Set GDB's working directory.

#### GDB Command

The corresponding GDB command is ``cd'`.

#### Example

    (gdb)
    -environment-cd /kwikemart/marge/ezannoni/flathead-dev/devo/gdb
    ^done
    (gdb)

### The `-environment-directory` Command

#### Synopsis

     -environment-directory [ -r ] [ pathdir ]+

Add directories pathdir to beginning of search path for source files. If the ``-r'` option is used, the search path is reset to the default search path. If directories pathdir are supplied in addition to the ``-r'` option, the search path is first reset and then addition occurs as normal. Multiple directories may be specified, separated by blanks. Specifying multiple directories in a single command results in the directories added to the beginning of the search path in the same order they were presented in the command. If blanks are needed as part of a directory name, double-quotes should be used around the name. In the command output, the path will show up separated by the system directory-separator character. The directory-separator character must not be used in any directory name. If no directories are specified, the current search path is displayed.

#### GDB Command

The corresponding GDB command is ``dir'`.

#### Example

    (gdb)
    -environment-directory /kwikemart/marge/ezannoni/flathead-dev/devo/gdb
    ^done,source-path="/kwikemart/marge/ezannoni/flathead-dev/devo/gdb:$cdir:$cwd"
    (gdb)
    -environment-directory ""
    ^done,source-path="/kwikemart/marge/ezannoni/flathead-dev/devo/gdb:$cdir:$cwd"
    (gdb)
    -environment-directory -r /home/jjohnstn/src/gdb /usr/src
    ^done,source-path="/home/jjohnstn/src/gdb:/usr/src:$cdir:$cwd"
    (gdb)
    -environment-directory -r
    ^done,source-path="$cdir:$cwd"
    (gdb)

### The `-environment-path` Command

#### Synopsis

     -environment-path [ -r ] [ pathdir ]+

Add directories pathdir to beginning of search path for object files. If the ``-r'` option is used, the search path is reset to the original search path that existed at gdb start-up. If directories pathdir are supplied in addition to the ``-r'` option, the search path is first reset and then addition occurs as normal. Multiple directories may be specified, separated by blanks. Specifying multiple directories in a single command results in the directories added to the beginning of the search path in the same order they were presented in the command. If blanks are needed as part of a directory name, double-quotes should be used around the name. In the command output, the path will show up separated by the system directory-separator character. The directory-separator character must not be used in any directory name. If no directories are specified, the current path is displayed.

#### GDB Command

The corresponding GDB command is ``path'`.

#### Example

    (gdb)
    -environment-path
    ^done,path="/usr/bin"
    (gdb)
    -environment-path /kwikemart/marge/ezannoni/flathead-dev/ppc-eabi/gdb /bin
    ^done,path="/kwikemart/marge/ezannoni/flathead-dev/ppc-eabi/gdb:/bin:/usr/bin"
    (gdb)
    -environment-path -r /usr/local/bin
    ^done,path="/usr/local/bin:/usr/bin"
    (gdb)

### The `-environment-pwd` Command

#### Synopsis

     -environment-pwd

Show the current working directory.

#### GDB Command

The corresponding GDB command is ``pwd'`.

#### Example

    (gdb)
    -environment-pwd
    ^done,cwd="/kwikemart/marge/ezannoni/flathead-dev/devo/gdb"
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.9 GDB/MI Thread Commands

### The `-thread-info` Command

#### Synopsis

     -thread-info

#### GDB Command

No equivalent.

#### Example

N.A.

### The `-thread-list-all-threads` Command

#### Synopsis

     -thread-list-all-threads

#### GDB Command

The equivalent GDB command is ``info threads'`.

#### Example

N.A.

### The `-thread-list-ids` Command

#### Synopsis

     -thread-list-ids

Produces a list of the currently known GDB thread ids. At the end of the list it also prints the total number of such threads.

#### GDB Command

Part of ``info threads'` supplies the same information.

#### Example

No threads present, besides the main process:

    (gdb)
    -thread-list-ids
    ^done,thread-ids={},number-of-threads="0"
    (gdb)

Several threads:

    (gdb)
    -thread-list-ids
    ^done,thread-ids={thread-id="3",thread-id="2",thread-id="1"},
    number-of-threads="3"
    (gdb)

### The `-thread-select` Command

#### Synopsis

     -thread-select threadnum

Make threadnum the current thread. It prints the number of the new current thread, and the topmost frame for that thread.

#### GDB Command

The corresponding GDB command is ``thread'`.

#### Example

    (gdb)
    -exec-next
    ^running
    (gdb)
    *stopped,reason="end-stepping-range",thread-id="2",line="187",
    file="../../../devo/gdb/testsuite/gdb.threads/linux-dp.c"
    (gdb)
    -thread-list-ids
    ^done,
    thread-ids={thread-id="3",thread-id="2",thread-id="1"},
    number-of-threads="3"
    (gdb)
    -thread-select 3
    ^done,new-thread-id="3",
    frame={level="0",func="vprintf",
    args=[{name="format",value="0x8048e9c \"%*s%c %d %c\\n\""},
    {name="arg",value="0x2"}],file="vprintf.c",line="31"}
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.10 GDB/MI Program Execution

These are the asynchronous commands which generate the out-of-band record ``*stopped'`. Currently GDB only really executes asynchronously with remote targets and this interaction is mimicked in other cases.

### The `-exec-continue` Command

#### Synopsis

     -exec-continue

Resumes the execution of the inferior program until a breakpoint is encountered, or until the inferior exits.

#### GDB Command

The corresponding GDB corresponding is ``continue'`.

#### Example

    -exec-continue
    ^running
    (gdb)
    @Hello world
    *stopped,reason="breakpoint-hit",bkptno="2",frame={func="foo",args=[],
    file="hello.c",fullname="/home/foo/bar/hello.c",line="13"}
    (gdb)

### The `-exec-finish` Command

#### Synopsis

     -exec-finish

Resumes the execution of the inferior program until the current function is exited. Displays the results returned by the function.

#### GDB Command

The corresponding GDB command is ``finish'`.

#### Example

Function returning `void`.

    -exec-finish
    ^running
    (gdb)
    @hello from foo
    *stopped,reason="function-finished",frame={func="main",args=[],
    file="hello.c",fullname="/home/foo/bar/hello.c",line="7"}
    (gdb)

Function returning other than `void`. The name of the internal GDB variable storing the result is printed, together with the value itself.

    -exec-finish
    ^running
    (gdb)
    *stopped,reason="function-finished",frame={addr="0x000107b0",func="foo",
    args=[{name="a",value="1"],{name="b",value="9"}},
    file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    gdb-result-var="$1",return-value="0"
    (gdb)

### The `-exec-interrupt` Command

#### Synopsis

     -exec-interrupt

Interrupts the background execution of the target. Note how the token associated with the stop message is the one for the execution command that has been interrupted. The token for the interrupt itself only appears in the ``^done'` output. If the user is trying to interrupt a non-running program, an error message will be printed.

#### GDB Command

The corresponding GDB command is ``interrupt'`.

#### Example

    (gdb)
    111-exec-continue
    111^running

    (gdb)
    222-exec-interrupt
    222^done
    (gdb)
    111*stopped,signal-name="SIGINT",signal-meaning="Interrupt",
    frame={addr="0x00010140",func="foo",args=[],file="try.c",
    fullname="/home/foo/bar/try.c",line="13"}
    (gdb)

    (gdb)
    -exec-interrupt
    ^error,msg="mi_cmd_exec_interrupt: Inferior not executing."
    (gdb)

### The `-exec-next` Command

#### Synopsis

     -exec-next

Resumes execution of the inferior program, stopping when the beginning of the next source line is reached.

#### GDB Command

The corresponding GDB command is ``next'`.

#### Example

    -exec-next
    ^running
    (gdb)
    *stopped,reason="end-stepping-range",line="8",file="hello.c"
    (gdb)

### The `-exec-next-instruction` Command

#### Synopsis

     -exec-next-instruction

Executes one machine instruction. If the instruction is a function call, continues until the function returns. If the program stops at an instruction in the middle of a source line, the address will be printed as well.

#### GDB Command

The corresponding GDB command is ``nexti'`.

#### Example

    (gdb)
    -exec-next-instruction
    ^running

    (gdb)
    *stopped,reason="end-stepping-range",
    addr="0x000100d4",line="5",file="hello.c"
    (gdb)

### The `-exec-return` Command

#### Synopsis

     -exec-return

Makes current function return immediately. Doesn't execute the inferior. Displays the new current frame.

#### GDB Command

The corresponding GDB command is ``return'`.

#### Example

    (gdb)
    200-break-insert callee4
    200^done,bkpt={number="1",addr="0x00010734",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",line="8"}
    (gdb)
    000-exec-run
    000^running
    (gdb)
    000*stopped,reason="breakpoint-hit",bkptno="1",
    frame={func="callee4",args=[],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="8"}
    (gdb)
    205-break-delete
    205^done
    (gdb)
    111-exec-return
    111^done,frame={level="0",func="callee3",
    args=[{name="strarg",
    value="0x11940 \"A string argument.\""}],
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="18"}
    (gdb)

### The `-exec-run` Command

#### Synopsis

     -exec-run

Starts execution of the inferior from the beginning. The inferior executes until either a breakpoint is encountered or the program exits. In the latter case the output will include an exit code, if the program has exited exceptionally.

#### GDB Command

The corresponding GDB command is ``run'`.

#### Examples

    (gdb)
    -break-insert main
    ^done,bkpt={number="1",addr="0x0001072c",file="recursive2.c",line="4"}
    (gdb)
    -exec-run
    ^running
    (gdb)
    *stopped,reason="breakpoint-hit",bkptno="1",
    frame={func="main",args=[],file="recursive2.c",
    fullname="/home/foo/bar/recursive2.c",line="4"}
    (gdb)

Program exited normally:

    (gdb)
    -exec-run
    ^running
    (gdb)
    x = 55
    *stopped,reason="exited-normally"
    (gdb)

Program exited exceptionally:

    (gdb)
    -exec-run
    ^running
    (gdb)
    x = 55
    *stopped,reason="exited",exit-code="01"
    (gdb)

Another way the program can terminate is if it receives a signal such as `SIGINT`. In this case, GDB/MI displays this:

    (gdb)
    *stopped,reason="exited-signalled",signal-name="SIGINT",
    signal-meaning="Interrupt"

### The `-exec-step` Command

#### Synopsis

     -exec-step

Resumes execution of the inferior program, stopping when the beginning of the next source line is reached, if the next source line is not a function call. If it is, stop at the first instruction of the called function.

#### GDB Command

The corresponding GDB command is ``step'`.

#### Example

Stepping into a function:

    -exec-step
    ^running
    (gdb)
    *stopped,reason="end-stepping-range",
    frame={func="foo",args=[{name="a",value="10"},
    {name="b",value="0"}],file="recursive2.c",
    fullname="/home/foo/bar/recursive2.c",line="11"}
    (gdb)

Regular stepping:

    -exec-step
    ^running
    (gdb)
    *stopped,reason="end-stepping-range",line="14",file="recursive2.c"
    (gdb)

### The `-exec-step-instruction` Command

#### Synopsis

     -exec-step-instruction

Resumes the inferior which executes one machine instruction. The output, once GDB has stopped, will vary depending on whether we have stopped in the middle of a source line or not. In the former case, the address at which the program stopped will be printed as well.

#### GDB Command

The corresponding GDB command is ``stepi'`.

#### Example

    (gdb)
    -exec-step-instruction
    ^running

    (gdb)
    *stopped,reason="end-stepping-range",
    frame={func="foo",args=[],file="try.c",
    fullname="/home/foo/bar/try.c",line="10"}
    (gdb)
    -exec-step-instruction
    ^running

    (gdb)
    *stopped,reason="end-stepping-range",
    frame={addr="0x000100f4",func="foo",args=[],file="try.c",
    fullname="/home/foo/bar/try.c",line="10"}
    (gdb)

### The `-exec-until` Command

#### Synopsis

     -exec-until [ location ]

Executes the inferior until the location specified in the argument is reached. If there is no argument, the inferior executes until a source line greater than the current one is reached. The reason for stopping in this case will be ``location-reached'`.

#### GDB Command

The corresponding GDB command is ``until'`.

#### Example

    (gdb)
    -exec-until recursive2.c:6
    ^running
    (gdb)
    x = 55
    *stopped,reason="location-reached",frame={func="main",args=[],
    file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="6"}
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.11 GDB/MI Stack Manipulation Commands

### The `-stack-info-frame` Command

#### Synopsis

     -stack-info-frame

Get info on the selected frame.

#### GDB Command

The corresponding GDB command is ``info frame'` or ``frame'` (without arguments).

#### Example

    (gdb)
    -stack-info-frame
    ^done,frame={level="1",addr="0x0001076c",func="callee3",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="17"}
    (gdb)

### The `-stack-info-depth` Command

#### Synopsis

     -stack-info-depth [ max-depth ]

Return the depth of the stack. If the integer argument max-depth is specified, do not count beyond max-depth frames.

#### GDB Command

There's no equivalent GDB command.

#### Example

For a stack with frame levels 0 through 11:

    (gdb)
    -stack-info-depth
    ^done,depth="12"
    (gdb)
    -stack-info-depth 4
    ^done,depth="4"
    (gdb)
    -stack-info-depth 12
    ^done,depth="12"
    (gdb)
    -stack-info-depth 11
    ^done,depth="11"
    (gdb)
    -stack-info-depth 13
    ^done,depth="12"
    (gdb)

### The `-stack-list-arguments` Command

#### Synopsis

     -stack-list-arguments show-values
        [ low-frame high-frame ]

Display a list of the arguments for the frames between low-frame and high-frame (inclusive). If low-frame and high-frame are not provided, list the arguments for the whole call stack. If the two arguments are equal, show the single frame at the corresponding level. It is an error if low-frame is larger than the actual number of frames. On the other hand, high-frame may be larger than the actual number of frames, in which case only existing frames will be returned.

The show-values argument must have a value of 0 or 1. A value of 0 means that only the names of the arguments are listed, a value of 1 means that both names and values of the arguments are printed.

#### GDB Command

GDB does not have an equivalent command. `gdbtk` has a ``gdb_get_args'` command which partially overlaps with the functionality of ``-stack-list-arguments'`.

#### Example

    (gdb)
    -stack-list-frames
    ^done,
    stack=[
    frame={level="0",addr="0x00010734",func="callee4",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="8"},
    frame={level="1",addr="0x0001076c",func="callee3",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="17"},
    frame={level="2",addr="0x0001078c",func="callee2",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="22"},
    frame={level="3",addr="0x000107b4",func="callee1",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="27"},
    frame={level="4",addr="0x000107e0",func="main",
    file="../../../devo/gdb/testsuite/gdb.mi/basics.c",
    fullname="/home/foo/bar/devo/gdb/testsuite/gdb.mi/basics.c",line="32"}]
    (gdb)
    -stack-list-arguments 0
    ^done,
    stack-args=[
    frame={level="0",args=[]},
    frame={level="1",args=[name="strarg"]},
    frame={level="2",args=[name="intarg",name="strarg"]},
    frame={level="3",args=[name="intarg",name="strarg",name="fltarg"]},
    frame={level="4",args=[]}]
    (gdb)
    -stack-list-arguments 1
    ^done,
    stack-args=[
    frame={level="0",args=[]},
    frame={level="1",
     args=[{name="strarg",value="0x11940 \"A string argument.\""}]},
    frame={level="2",args=[
    {name="intarg",value="2"},
    {name="strarg",value="0x11940 \"A string argument.\""}]},
    {frame={level="3",args=[
    {name="intarg",value="2"},
    {name="strarg",value="0x11940 \"A string argument.\""},
    {name="fltarg",value="3.5"}]},
    frame={level="4",args=[]}]
    (gdb)
    -stack-list-arguments 0 2 2
    ^done,stack-args=[frame={level="2",args=[name="intarg",name="strarg"]}]
    (gdb)
    -stack-list-arguments 1 2 2
    ^done,stack-args=[frame={level="2",
    args=[{name="intarg",value="2"},
    {name="strarg",value="0x11940 \"A string argument.\""}]}]
    (gdb)

### The `-stack-list-frames` Command

#### Synopsis

     -stack-list-frames [ low-frame high-frame ]

List the frames currently on the stack. For each frame it displays the following info:

``level'`
  The frame number, 0 being the topmost frame, i.e., the innermost function.
``addr'`
  The `$pc` value for that frame.
``func'`
  Function name.
``file'`
  File name of the source file where the function lives.
``line'`
  Line number corresponding to the `$pc`.

If invoked without arguments, this command prints a backtrace for the whole stack. If given two integer arguments, it shows the frames whose levels are between the two arguments (inclusive). If the two arguments are equal, it shows the single frame at the corresponding level. It is an error if low-frame is larger than the actual number of frames. On the other hand, high-frame may be larger than the actual number of frames, in which case only existing frames will be returned.

#### GDB Command

The corresponding GDB commands are ``backtrace'` and ``where'`.

#### Example

Full stack backtrace:

    (gdb)
    -stack-list-frames
    ^done,stack=
    [frame={level="0",addr="0x0001076c",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="11"},
    frame={level="1",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="2",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="3",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="4",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="5",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="6",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="7",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="8",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="9",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="10",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="11",addr="0x00010738",func="main",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="4"}]
    (gdb)

Show frames between low_frame and high_frame:

    (gdb)
    -stack-list-frames 3 5
    ^done,stack=
    [frame={level="3",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="4",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"},
    frame={level="5",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"}]
    (gdb)

Show a single frame:

    (gdb)
    -stack-list-frames 3 3
    ^done,stack=
    [frame={level="3",addr="0x000107a4",func="foo",
      file="recursive2.c",fullname="/home/foo/bar/recursive2.c",line="14"}]
    (gdb)

### The `-stack-list-locals` Command

#### Synopsis

     -stack-list-locals print-values

Display the local variable names for the selected frame. If print-values is 0 or `--no-values`, print only the names of the variables; if it is 1 or `--all-values`, print also their values; and if it is 2 or `--simple-values`, print the name, type and value for simple data types and the name and type for arrays, structures and unions. In this last case, a frontend can immediately display the value of simple data types and create variable objects for other data types when the user wishes to explore their values in more detail.

#### GDB Command

``info locals'` in GDB, ``gdb_get_locals'` in `gdbtk`.

#### Example

    (gdb)
    -stack-list-locals 0
    ^done,locals=[name="A",name="B",name="C"]
    (gdb)
    -stack-list-locals --all-values
    ^done,locals=[{name="A",value="1"},{name="B",value="2"},
      {name="C",value="{1, 2, 3}"}]
    -stack-list-locals --simple-values
    ^done,locals=[{name="A",type="int",value="1"},
      {name="B",type="int",value="2"},{name="C",type="int [3]"}]
    (gdb)

### The `-stack-select-frame` Command

#### Synopsis

     -stack-select-frame framenum

Change the selected frame. Select a different frame framenum on the stack.

#### GDB Command

The corresponding GDB commands are ``frame'`, ``up'`, ``down'`, ``select-frame'`, ``up-silent'`, and ``down-silent'`.

#### Example

    (gdb)
    -stack-select-frame 2
    ^done
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.12 GDB/MI Variable Objects

### Introduction to Variable Objects

Variable objects are "object-oriented" MI interface for examining and changing values of expressions. Unlike some other MI interfaces that work with expressions, variable objects are specifically designed for simple and efficient presentation in the frontend. A variable object is identified by string name. When a variable object is created, the frontend specifies the expression for that variable object. The expression can be a simple variable, or it can be an arbitrary complex expression, and can even involve CPU registers. After creating a variable object, the frontend can invoke other variable object operations--for example to obtain or change the value of a variable object, or to change display format.

Variable objects have hierarchical tree structure. Any variable object that corresponds to a composite type, such as structure in C, has a number of child variable objects, for example corresponding to each element of a structure. A child variable object can itself have children, recursively. Recursion ends when we reach leaf variable objects, which always have built-in types. Child variable objects are created only by explicit request, so if a frontend is not interested in the children of a particular variable object, no child will be created.

For a leaf variable object it is possible to obtain its value as a string, or set the value from a string. String value can be also obtained for a non-leaf variable object, but it's generally a string that only indicates the type of the object, and does not list its contents. Assignment to a non-leaf variable object is not allowed. A frontend does not need to read the values of all variable objects each time the program stops. Instead, MI provides an update command that lists all variable objects whose values has changed since the last update operation. This considerably reduces the amount of data that must be transferred to the frontend. As noted above, children variable objects are created on demand, and only leaf variable objects have a real value. As result, gdb will read target memory only for leaf variables that frontend has created.

The automatic update is not always desirable. For example, a frontend might want to keep a value of some expression for future reference, and never update it. For another example, fetching memory is relatively slow for embedded targets, so a frontend might want to disable automatic update for the variables that are either not visible on the screen, or "closed". This is possible using so called "frozen variable objects". Such variable objects are never implicitly updated.

The following is the complete set of GDB/MI operations defined to access this functionality:

Operation | Description
`-var-create` | create a variable object
`-var-delete` | delete the variable object and/or its children
`-var-set-format` | set the display format of this variable
`-var-show-format` | show the display format of this variable
`-var-info-num-children` | tells how many children this object has
`-var-list-children` | return a list of the object's children
`-var-info-type` | show the type of this variable object
`-var-info-expression` | print parent-relative expression that this variable object represents
`-var-info-path-expression` | print full expression that this variable object represents
`-var-show-attributes` | is this variable editable? does it exist here?
`-var-evaluate-expression` | get the value of this variable
`-var-assign` | set the value of this variable
`-var-update` | update the variable and its children
`-var-set-frozen` | set frozeness attribute

In the next subsection we describe each operation in detail and suggest how it can be used.

### Description And Use of Operations on Variable Objects

### The `-var-create` Command

#### Synopsis

     -var-create {name | "-"}
        {frame-addr | "*"} expression

This operation creates a variable object, which allows the monitoring of a variable, the result of an expression, a memory cell or a CPU register.

The name parameter is the string by which the object can be referenced. It must be unique. If ``-'` is specified, the varobj system will generate a string "varNNNNNN" automatically. It will be unique provided that one does not specify name on that format. The command fails if a duplicate name is found.

The frame under which the expression should be evaluated can be specified by frame-addr. A ``*'` indicates that the current frame should be used.

expression is any expression valid on the current language set (must not begin with a ``*'`), or one of the following:

- ``*addr'`, where addr is the address of a memory cell

- ``*addr-addr'` -- a memory address range (TBD)

- ``$regname'` -- a CPU register name

#### Result

This operation returns the name, number of children and the type of the object created. Type is returned as a string as the ones generated by the GDB CLI:

     name="name",numchild="N",type="type"

### The `-var-delete` Command

#### Synopsis

     -var-delete [ -c ] name

Deletes a previously created variable object and all of its children. With the ``-c'` option, just deletes the children.

Returns an error if the object name is not found.

### The `-var-set-format` Command

#### Synopsis

     -var-set-format name format-spec

Sets the output format for the value of the object name to be format-spec.

The syntax for the format-spec is as follows:

     format-spec ==>
     {binary | decimal | hexadecimal | octal | natural}

The natural format is the default format choosen automatically based on the variable type (like decimal for an `int`, hex for pointers, etc.).

For a variable with children, the format is set only on the variable itself, and the children are not affected.

### The `-var-show-format` Command

#### Synopsis

     -var-show-format name

Returns the format used to display the value of the object name.

     format ==>
     format-spec

### The `-var-info-num-children` Command

#### Synopsis

     -var-info-num-children name

Returns the number of children of a variable object name:

     numchild=n

### The `-var-list-children` Command

#### Synopsis

     -var-list-children [print-values] name

Return a list of the children of the specified variable object and create variable objects for them, if they do not already exist. With a single argument or if print-values has a value for of 0 or `--no-values`, print only the names of the variables; if print-values is 1 or `--all-values`, also print their values; and if it is 2 or `--simple-values` print the name and value for simple data types and just the name for arrays, structures and unions.

#### Example

    (gdb)
     -var-list-children n
     ^done,numchild=n,children=[{name=name,
     numchild=n,type=type},(repeats N times)]
    (gdb)
     -var-list-children --all-values n
     ^done,numchild=n,children=[{name=name,
     numchild=n,value=value,type=type},(repeats N times)]

### The `-var-info-type` Command

#### Synopsis

     -var-info-type name

Returns the type of the specified variable name. The type is returned as a string in the same format as it is output by the GDB CLI:

     type=typename

### The `-var-info-expression` Command

#### Synopsis

     -var-info-expression name

Returns a string that is suitable for presenting this variable object in user interface. The string is generally not valid expression in the current language, and cannot be evaluated.

For example, if `a` is an array, and variable object `A` was created for `a`, then we'll get this output:

    (gdb) -var-info-expression A.1
    ^done,lang="C",exp="1"

Here, the values of `lang` can be `{"C" | "C++" | "Java"}`.

Note that the output of the `-var-list-children` command also includes those expressions, so the `-var-info-expression` command is of limited use.

### The `-var-info-path-expression` Command

#### Synopsis

     -var-info-path-expression name

Returns an expression that can be evaluated in the current context and will yield the same value that a variable object has. Compare this with the `-var-info-expression` command, which result can be used only for UI presentation. Typical use of the `-var-info-path-expression` command is creating a watchpoint from a variable object.

For example, suppose `C` is a C`++` class, derived from class `Base`, and that the `Base` class has a member called `m_size`. Assume a variable `c` is has the type of `C` and a variable object `C` was created for variable `c`. Then, we'll get this output:

    (gdb) -var-info-path-expression C.Base.public.m_size
    ^done,path_expr=((Base)c).m_size)

### The `-var-show-attributes` Command

#### Synopsis

     -var-show-attributes name

List attributes of the specified variable object name:

     status=attr [ ( ,attr )* ]

where attr is `{ { editable | noneditable } | TBD }`.

### The `-var-evaluate-expression` Command

#### Synopsis

     -var-evaluate-expression name

Evaluates the expression that is represented by the specified variable object and returns its value as a string. The format of the string can be changed using the `-var-set-format` command.

     value=value

Note that one must invoke `-var-list-children` for a variable before the value of a child variable can be evaluated.

### The `-var-assign` Command

#### Synopsis

     -var-assign name expression

Assigns the value of expression to the variable object specified by name. The object must be ``editable'`. If the variable's value is altered by the assign, the variable will show up in any subsequent `-var-update` list.

#### Example

    (gdb)
    -var-assign var1 3
    ^done,value="3"
    (gdb)
    -var-update *
    ^done,changelist=[{name="var1",in_scope="true",type_changed="false"}]
    (gdb)

### The `-var-update` Command

#### Synopsis

     -var-update [print-values] {name | "*"}

Reevaluate the expressions corresponding to the variable object name and all its direct and indirect children, and return the list of variable objects whose values have changed; name must be a root variable object. Here, "changed" means that the result of `-var-evaluate-expression` before and after the `-var-update` is different. If ``*'` is used as the variable object names, all existing variable objects are updated, except for frozen ones (see -var-set-frozen). The option print-values determines whether both names and values, or just names are printed. The possible values of this options are the same as for `-var-list-children` (see -var-list-children). It is recommended to use the ``--all-values'` option, to reduce the number of MI commands needed on each program stop.

#### Example

    (gdb)
    -var-assign var1 3
    ^done,value="3"
    (gdb)
    -var-update --all-values var1
    ^done,changelist=[{name="var1",value="3",in_scope="true",
    type_changed="false"}]
    (gdb)

The field in_scope may take three values:

`"true"`
  The variable object's current value is valid.

`"false"`
  The variable object does not currently hold a valid value but it may hold one in the future if its associated expression comes back into scope.

`"invalid"`
  The variable object no longer holds a valid value. This can occur when the executable file being debugged has changed, either through recompilation or by using the GDB `file` command. The front end should normally choose to delete these variable objects.

In the future new values may be added to this list so the front should be prepared for this possibility. See section GDB/MI Development and Front Ends.

### The `-var-set-frozen` Command

#### Synopsis

     -var-set-frozen name flag

Set the frozenness flag on the variable object name. The flag parameter should be either ``1'` to make the variable frozen or ``0'` to make it unfrozen. If a variable object is frozen, then neither itself, nor any of its children, are implicitly updated by `-var-update` of a parent variable or by `-var-update *`. Only `-var-update` of the variable itself will update its value and values of its children. After a variable object is unfrozen, it is implicitly updated by all subsequent `-var-update` operations. Unfreezing a variable does not update it, only subsequent `-var-update` does.

#### Example

    (gdb)
    -var-set-frozen V 1
    ^done
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.13 GDB/MI Data Manipulation

This section describes the GDB/MI commands that manipulate data: examine memory and registers, evaluate expressions, etc.

### The `-data-disassemble` Command

#### Synopsis

     -data-disassemble
        [ -s start-addr -e end-addr ]
      | [ -f filename -l linenum [ -n lines ] ]
      -- mode

Where:

``start-addr'`
  is the beginning address (or `$pc`)
``end-addr'`
  is the end address
``filename'`
  is the name of the file to disassemble
``linenum'`
  is the line number to disassemble around
``lines'`
  is the number of disassembly lines to be produced. If it is -1, the whole function will be disassembled, in case no end-addr is specified. If end-addr is specified as a non-zero value, and lines is lower than the number of disassembly lines between start-addr and end-addr, only lines lines are displayed; if lines is higher than the number of lines between start-addr and end-addr, only the lines up to end-addr are displayed.
``mode'`
  is either 0 (meaning only disassembly) or 1 (meaning mixed source and disassembly).

#### Result

The output for each instruction is composed of four fields:

- Address
- Func-name
- Offset
- Instruction

Note that whatever included in the instruction field, is not manipulated directly by GDB/MI, i.e., it is not possible to adjust its format.

#### GDB Command

There's no direct mapping from this command to the CLI.

#### Example

Disassemble from the current value of `$pc` to `$pc + 20`:

    (gdb)
    -data-disassemble -s $pc -e "$pc + 20" -- 0
    ^done,
    asm_insns=[
    {address="0x000107c0",func-name="main",offset="4",
    inst="mov  2, %o0"},
    {address="0x000107c4",func-name="main",offset="8",
    inst="sethi  %hi(0x11800), %o2"},
    {address="0x000107c8",func-name="main",offset="12",
    inst="or  %o2, 0x140, %o1\t! 0x11940 <_lib_version+8>"},
    {address="0x000107cc",func-name="main",offset="16",
    inst="sethi  %hi(0x11800), %o2"},
    {address="0x000107d0",func-name="main",offset="20",
    inst="or  %o2, 0x168, %o4\t! 0x11968 <_lib_version+48>"}]
    (gdb)

Disassemble the whole `main` function. Line 32 is part of `main`.

    -data-disassemble -f basics.c -l 32 -- 0
    ^done,asm_insns=[
    {address="0x000107bc",func-name="main",offset="0",
    inst="save  %sp, -112, %sp"},
    {address="0x000107c0",func-name="main",offset="4",
    inst="mov   2, %o0"},
    {address="0x000107c4",func-name="main",offset="8",
    inst="sethi %hi(0x11800), %o2"},
    [...]
    {address="0x0001081c",func-name="main",offset="96",inst="ret "},
    {address="0x00010820",func-name="main",offset="100",inst="restore "}]
    (gdb)

Disassemble 3 instructions from the start of `main`:

    (gdb)
    -data-disassemble -f basics.c -l 32 -n 3 -- 0
    ^done,asm_insns=[
    {address="0x000107bc",func-name="main",offset="0",
    inst="save  %sp, -112, %sp"},
    {address="0x000107c0",func-name="main",offset="4",
    inst="mov  2, %o0"},
    {address="0x000107c4",func-name="main",offset="8",
    inst="sethi  %hi(0x11800), %o2"}]
    (gdb)

Disassemble 3 instructions from the start of `main` in mixed mode:

    (gdb)
    -data-disassemble -f basics.c -l 32 -n 3 -- 1
    ^done,asm_insns=[
    src_and_asm_line={line="31",
    file="/kwikemart/marge/ezannoni/flathead-dev/devo/gdb/ \
      testsuite/gdb.mi/basics.c",line_asm_insn=[
    {address="0x000107bc",func-name="main",offset="0",
    inst="save  %sp, -112, %sp"}]},
    src_and_asm_line={line="32",
    file="/kwikemart/marge/ezannoni/flathead-dev/devo/gdb/ \
      testsuite/gdb.mi/basics.c",line_asm_insn=[
    {address="0x000107c0",func-name="main",offset="4",
    inst="mov  2, %o0"},
    {address="0x000107c4",func-name="main",offset="8",
    inst="sethi  %hi(0x11800), %o2"}]}]
    (gdb)

### The `-data-evaluate-expression` Command

#### Synopsis

     -data-evaluate-expression expr

Evaluate expr as an expression. The expression could contain an inferior function call. The function call will execute synchronously. If the expression contains spaces, it must be enclosed in double quotes.

#### GDB Command

The corresponding GDB commands are ``print'`, ``output'`, and ``call'`. In `gdbtk` only, there's a corresponding ``gdb_eval'` command.

#### Example

In the following example, the numbers that precede the commands are the tokens described in GDB/MI Command Syntax. Notice how GDB/MI returns the same tokens in its output.

    211-data-evaluate-expression A
    211^done,value="1"
    (gdb)
    311-data-evaluate-expression &A
    311^done,value="0xefffeb7c"
    (gdb)
    411-data-evaluate-expression A+3
    411^done,value="4"
    (gdb)
    511-data-evaluate-expression "A + 3"
    511^done,value="4"
    (gdb)

### The `-data-list-changed-registers` Command

#### Synopsis

     -data-list-changed-registers

Display a list of the registers that have changed.

#### GDB Command

GDB doesn't have a direct analog for this command; `gdbtk` has the corresponding command ``gdb_changed_register_list'`.

#### Example

On a PPC MBX board:

    (gdb)
    -exec-continue
    ^running

    (gdb)
    *stopped,reason="breakpoint-hit",bkptno="1",frame={func="main",
    args=[],file="try.c",fullname="/home/foo/bar/try.c",line="5"}
    (gdb)
    -data-list-changed-registers
    ^done,changed-registers=["0","1","2","4","5","6","7","8","9",
    "10","11","13","14","15","16","17","18","19","20","21","22","23",
    "24","25","26","27","28","30","31","64","65","66","67","69"]
    (gdb)

### The `-data-list-register-names` Command

#### Synopsis

     -data-list-register-names [ ( regno )+ ]

Show a list of register names for the current target. If no arguments are given, it shows a list of the names of all the registers. If integer numbers are given as arguments, it will print a list of the names of the registers corresponding to the arguments. To ensure consistency between a register name and its number, the output list may include empty register names.

#### GDB Command

GDB does not have a command which corresponds to ``-data-list-register-names'`. In `gdbtk` there is a corresponding command ``gdb_regnames'`.

#### Example

For the PPC MBX board:

    (gdb)
    -data-list-register-names
    ^done,register-names=["r0","r1","r2","r3","r4","r5","r6","r7",
    "r8","r9","r10","r11","r12","r13","r14","r15","r16","r17","r18",
    "r19","r20","r21","r22","r23","r24","r25","r26","r27","r28","r29",
    "r30","r31","f0","f1","f2","f3","f4","f5","f6","f7","f8","f9",
    "f10","f11","f12","f13","f14","f15","f16","f17","f18","f19","f20",
    "f21","f22","f23","f24","f25","f26","f27","f28","f29","f30","f31",
    "", "pc","ps","cr","lr","ctr","xer"]
    (gdb)
    -data-list-register-names 1 2 3
    ^done,register-names=["r1","r2","r3"]
    (gdb)

### The `-data-list-register-values` Command

#### Synopsis

     -data-list-register-values fmt [ ( regno )*]

Display the registers' contents. fmt is the format according to which the registers' contents are to be returned, followed by an optional list of numbers specifying the registers to display. A missing list of numbers indicates that the contents of all the registers must be returned.

Allowed formats for fmt are:

`x`
  Hexadecimal
`o`
  Octal
`t`
  Binary
`d`
  Decimal
`r`
  Raw
`N`
  Natural

#### GDB Command

The corresponding GDB commands are ``info reg'`, ``info all-reg'`, and (in `gdbtk`) ``gdb_fetch_registers'`.

#### Example

For a PPC MBX board (note: line breaks are for readability only, they don't appear in the actual output):

    (gdb)
    -data-list-register-values r 64 65
    ^done,register-values=[{number="64",value="0xfe00a300"},
    {number="65",value="0x00029002"}]
    (gdb)
    -data-list-register-values x
    ^done,register-values=[{number="0",value="0xfe0043c8"},
    {number="1",value="0x3fff88"},{number="2",value="0xfffffffe"},
    {number="3",value="0x0"},{number="4",value="0xa"},
    {number="5",value="0x3fff68"},{number="6",value="0x3fff58"},
    {number="7",value="0xfe011e98"},{number="8",value="0x2"},
    {number="9",value="0xfa202820"},{number="10",value="0xfa202808"},
    {number="11",value="0x1"},{number="12",value="0x0"},
    {number="13",value="0x4544"},{number="14",value="0xffdfffff"},
    {number="15",value="0xffffffff"},{number="16",value="0xfffffeff"},
    {number="17",value="0xefffffed"},{number="18",value="0xfffffffe"},
    {number="19",value="0xffffffff"},{number="20",value="0xffffffff"},
    {number="21",value="0xffffffff"},{number="22",value="0xfffffff7"},
    {number="23",value="0xffffffff"},{number="24",value="0xffffffff"},
    {number="25",value="0xffffffff"},{number="26",value="0xfffffffb"},
    {number="27",value="0xffffffff"},{number="28",value="0xf7bfffff"},
    {number="29",value="0x0"},{number="30",value="0xfe010000"},
    {number="31",value="0x0"},{number="32",value="0x0"},
    {number="33",value="0x0"},{number="34",value="0x0"},
    {number="35",value="0x0"},{number="36",value="0x0"},
    {number="37",value="0x0"},{number="38",value="0x0"},
    {number="39",value="0x0"},{number="40",value="0x0"},
    {number="41",value="0x0"},{number="42",value="0x0"},
    {number="43",value="0x0"},{number="44",value="0x0"},
    {number="45",value="0x0"},{number="46",value="0x0"},
    {number="47",value="0x0"},{number="48",value="0x0"},
    {number="49",value="0x0"},{number="50",value="0x0"},
    {number="51",value="0x0"},{number="52",value="0x0"},
    {number="53",value="0x0"},{number="54",value="0x0"},
    {number="55",value="0x0"},{number="56",value="0x0"},
    {number="57",value="0x0"},{number="58",value="0x0"},
    {number="59",value="0x0"},{number="60",value="0x0"},
    {number="61",value="0x0"},{number="62",value="0x0"},
    {number="63",value="0x0"},{number="64",value="0xfe00a300"},
    {number="65",value="0x29002"},{number="66",value="0x202f04b5"},
    {number="67",value="0xfe0043b0"},{number="68",value="0xfe00b3e4"},
    {number="69",value="0x20002b03"}]
    (gdb)

### The `-data-read-memory` Command

#### Synopsis

     -data-read-memory [ -o byte-offset ]
       address word-format word-size
       nr-rows nr-cols [ aschar ]

where:

``address'`
  An expression specifying the address of the first memory word to be read. Complex expressions containing embedded white space should be quoted using the C convention.

``word-format'`
  The format to be used to print the memory words. The notation is the same as for GDB's `print` command (see section Output Formats).

``word-size'`
  The size of each memory word in bytes.

``nr-rows'`
  The number of rows in the output table.

``nr-cols'`
  The number of columns in the output table.

``aschar'`
  If present, indicates that each row should include an ASCII dump. The value of aschar is used as a padding character when a byte is not a member of the printable ASCII character set (printable ASCII characters are those whose code is between 32 and 126, inclusively).

``byte-offset'`
  An offset to add to the address before fetching memory.

This command displays memory contents as a table of nr-rows by nr-cols words, each word being word-size bytes. In total, `nr-rows * nr-cols * word-size` bytes are read (returned as ``total-bytes'`). Should less than the requested number of bytes be returned by the target, the missing words are identified using ``N/A'`. The number of bytes read from the target is returned in ``nr-bytes'` and the starting address used to read memory in ``addr'`.

The address of the next/previous row or page is available in ``next-row'` and ``prev-row'`, ``next-page'` and ``prev-page'`.

#### GDB Command

The corresponding GDB command is ``x'`. `gdbtk` has ``gdb_get_mem'` memory read command.

#### Example

Read six bytes of memory starting at `bytes+6` but then offset by `-6` bytes. Format as three rows of two columns. One byte per word. Display each word in hex.

    (gdb)
    9-data-read-memory -o -6 -- bytes+6 x 1 3 2
    9^done,addr="0x00001390",nr-bytes="6",total-bytes="6",
    next-row="0x00001396",prev-row="0x0000138e",next-page="0x00001396",
    prev-page="0x0000138a",memory=[
    {addr="0x00001390",data=["0x00","0x01"]},
    {addr="0x00001392",data=["0x02","0x03"]},
    {addr="0x00001394",data=["0x04","0x05"]}]
    (gdb)

Read two bytes of memory starting at address `shorts + 64` and display as a single word formatted in decimal.

    (gdb)
    5-data-read-memory shorts+64 d 2 1 1
    5^done,addr="0x00001510",nr-bytes="2",total-bytes="2",
    next-row="0x00001512",prev-row="0x0000150e",
    next-page="0x00001512",prev-page="0x0000150e",memory=[
    {addr="0x00001510",data=["128"]}]
    (gdb)

Read thirty two bytes of memory starting at `bytes+16` and format as eight rows of four columns. Include a string encoding with ``x'` used as the non-printable character.

    (gdb)
    4-data-read-memory bytes+16 x 1 8 4 x
    4^done,addr="0x000013a0",nr-bytes="32",total-bytes="32",
    next-row="0x000013c0",prev-row="0x0000139c",
    next-page="0x000013c0",prev-page="0x00001380",memory=[
    {addr="0x000013a0",data=["0x10","0x11","0x12","0x13"],ascii="xxxx"},
    {addr="0x000013a4",data=["0x14","0x15","0x16","0x17"],ascii="xxxx"},
    {addr="0x000013a8",data=["0x18","0x19","0x1a","0x1b"],ascii="xxxx"},
    {addr="0x000013ac",data=["0x1c","0x1d","0x1e","0x1f"],ascii="xxxx"},
    {addr="0x000013b0",data=["0x20","0x21","0x22","0x23"],ascii=" !\"#"},
    {addr="0x000013b4",data=["0x24","0x25","0x26","0x27"],ascii="$%&'"},
    {addr="0x000013b8",data=["0x28","0x29","0x2a","0x2b"],ascii="()*+"},
    {addr="0x000013bc",data=["0x2c","0x2d","0x2e","0x2f"],ascii=",-./"}]
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.14 GDB/MI Tracepoint Commands

The tracepoint commands are not yet implemented.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.15 GDB/MI Symbol Query Commands

### The `-symbol-info-address` Command

#### Synopsis

     -symbol-info-address symbol

Describe where symbol is stored.

#### GDB Command

The corresponding GDB command is ``info address'`.

#### Example

N.A.

### The `-symbol-info-file` Command

#### Synopsis

     -symbol-info-file

Show the file for the symbol.

#### GDB Command

There's no equivalent GDB command. `gdbtk` has ``gdb_find_file'`.

#### Example

N.A.

### The `-symbol-info-function` Command

#### Synopsis

     -symbol-info-function

Show which function the symbol lives in.

#### GDB Command

``gdb_get_function'` in `gdbtk`.

#### Example

N.A.

### The `-symbol-info-line` Command

#### Synopsis

     -symbol-info-line

Show the core addresses of the code for a source line.

#### GDB Command

The corresponding GDB command is ``info line'`. `gdbtk` has the ``gdb_get_line'` and ``gdb_get_file'` commands.

#### Example

N.A.

### The `-symbol-info-symbol` Command

#### Synopsis

     -symbol-info-symbol addr

Describe what symbol is at location addr.

#### GDB Command

The corresponding GDB command is ``info symbol'`.

#### Example

N.A.

### The `-symbol-list-functions` Command

#### Synopsis

     -symbol-list-functions

List the functions in the executable.

#### GDB Command

``info functions'` in GDB, ``gdb_listfunc'` and ``gdb_search'` in `gdbtk`.

#### Example

N.A.

### The `-symbol-list-lines` Command

#### Synopsis

     -symbol-list-lines filename

Print the list of lines that contain code and their associated program addresses for the given source filename. The entries are sorted in ascending PC order.

#### GDB Command

There is no corresponding GDB command.

#### Example

    (gdb)
    -symbol-list-lines basics.c
    ^done,lines=[{pc="0x08048554",line="7"},{pc="0x0804855a",line="8"}]
    (gdb)

### The `-symbol-list-types` Command

#### Synopsis

     -symbol-list-types

List all the type names.

#### GDB Command

The corresponding commands are ``info types'` in GDB, ``gdb_search'` in `gdbtk`.

#### Example

N.A.

### The `-symbol-list-variables` Command

#### Synopsis

     -symbol-list-variables

List all the global and static variable names.

#### GDB Command

``info variables'` in GDB, ``gdb_search'` in `gdbtk`.

#### Example

N.A.

### The `-symbol-locate` Command

#### Synopsis

     -symbol-locate

#### GDB Command

``gdb_loc'` in `gdbtk`.

#### Example

N.A.

### The `-symbol-type` Command

#### Synopsis

     -symbol-type variable

Show type of variable.

#### GDB Command

The corresponding GDB command is ``ptype'`, `gdbtk` has ``gdb_obj_variable'`.

#### Example

N.A.

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.16 GDB/MI File Commands

This section describes the GDB/MI commands to specify executable file names and to read in and obtain symbol table information.

### The `-file-exec-and-symbols` Command

#### Synopsis

     -file-exec-and-symbols file

Specify the executable file to be debugged. This file is the one from which the symbol table is also read. If no file is specified, the command clears the executable and symbol information. If breakpoints are set when using this command with no arguments, GDB will produce error messages. Otherwise, no output is produced, except a completion notification.

#### GDB Command

The corresponding GDB command is ``file'`.

#### Example

    (gdb)
    -file-exec-and-symbols /kwikemart/marge/ezannoni/TRUNK/mbx/hello.mbx
    ^done
    (gdb)

### The `-file-exec-file` Command

#### Synopsis

     -file-exec-file file

Specify the executable file to be debugged. Unlike ``-file-exec-and-symbols'`, the symbol table is not read from this file. If used without argument, GDB clears the information about the executable file. No output is produced, except a completion notification.

#### GDB Command

The corresponding GDB command is ``exec-file'`.

#### Example

    (gdb)
    -file-exec-file /kwikemart/marge/ezannoni/TRUNK/mbx/hello.mbx
    ^done
    (gdb)

### The `-file-list-exec-sections` Command

#### Synopsis

     -file-list-exec-sections

List the sections of the current executable file.

#### GDB Command

The GDB command ``info file'` shows, among the rest, the same information as this command. `gdbtk` has a corresponding command ``gdb_load_info'`.

#### Example

N.A.

### The `-file-list-exec-source-file` Command

#### Synopsis

     -file-list-exec-source-file

List the line number, the current source file, and the absolute path to the current source file for the current executable. The macro information field has a value of ``1'` or ``0'` depending on whether or not the file includes preprocessor macro information.

#### GDB Command

The GDB equivalent is ``info source'`

#### Example

    (gdb)
    123-file-list-exec-source-file
    123^done,line="1",file="foo.c",fullname="/home/bar/foo.c,macro-info="1"
    (gdb)

### The `-file-list-exec-source-files` Command

#### Synopsis

     -file-list-exec-source-files

List the source files for the current executable.

It will always output the filename, but only when GDB can find the absolute file name of a source file, will it output the fullname.

#### GDB Command

The GDB equivalent is ``info sources'`. `gdbtk` has an analogous command ``gdb_listfiles'`.

#### Example

    (gdb)
    -file-list-exec-source-files
    ^done,files=[
    {file=foo.c,fullname=/home/foo.c},
    {file=/home/bar.c,fullname=/home/bar.c},
    {file=gdb_could_not_find_fullpath.c}]
    (gdb)

### The `-file-list-shared-libraries` Command

#### Synopsis

     -file-list-shared-libraries

List the shared libraries in the program.

#### GDB Command

The corresponding GDB command is ``info shared'`.

#### Example

N.A.

### The `-file-list-symbol-files` Command

#### Synopsis

     -file-list-symbol-files

List symbol files.

#### GDB Command

The corresponding GDB command is ``info file'` (part of it).

#### Example

N.A.

### The `-file-symbol-file` Command

#### Synopsis

     -file-symbol-file file

Read symbol table info from the specified file argument. When used without arguments, clears GDB's symbol table info. No output is produced, except for a completion notification.

#### GDB Command

The corresponding GDB command is ``symbol-file'`.

#### Example

    (gdb)
    -file-symbol-file /kwikemart/marge/ezannoni/TRUNK/mbx/hello.mbx
    ^done
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.17 GDB/MI Target Manipulation Commands

### The `-target-attach` Command

#### Synopsis

     -target-attach pid | file

Attach to a process pid or a file file outside of GDB.

#### GDB Command

The corresponding GDB command is ``attach'`.

#### Example

N.A.

### The `-target-compare-sections` Command

#### Synopsis

     -target-compare-sections [ section ]

Compare data of section section on target to the exec file. Without the argument, all sections are compared.

#### GDB Command

The GDB equivalent is ``compare-sections'`.

#### Example

N.A.

### The `-target-detach` Command

#### Synopsis

     -target-detach

Detach from the remote target which normally resumes its execution. There's no output.

#### GDB Command

The corresponding GDB command is ``detach'`.

#### Example

    (gdb)
    -target-detach
    ^done
    (gdb)

### The `-target-disconnect` Command

#### Synopsis

     -target-disconnect

Disconnect from the remote target. There's no output and the target is generally not resumed.

#### GDB Command

The corresponding GDB command is ``disconnect'`.

#### Example

    (gdb)
    -target-disconnect
    ^done
    (gdb)

### The `-target-download` Command

#### Synopsis

     -target-download

Loads the executable onto the remote target. It prints out an update message every half second, which includes the fields:

``section'`
  The name of the section.
``section-sent'`
  The size of what has been sent so far for that section.
``section-size'`
  The size of the section.
``total-sent'`
  The total size of what was sent so far (the current and the previous sections).
``total-size'`
  The size of the overall executable to download.

Each message is sent as status record (see section GDB/MI Output Syntax).

In addition, it prints the name and size of the sections, as they are downloaded. These messages include the following fields:

``section'`
  The name of the section.
``section-size'`
  The size of the section.
``total-size'`
  The size of the overall executable to download.

At the end, a summary is printed.

#### GDB Command

The corresponding GDB command is ``load'`.

#### Example

Note: each status message appears on a single line. Here the messages have been broken down so that they can fit onto a page.

    (gdb)
    -target-download
    +download,{section=".text",section-size="6668",total-size="9880"}
    +download,{section=".text",section-sent="512",section-size="6668",
    total-sent="512",total-size="9880"}
    +download,{section=".text",section-sent="1024",section-size="6668",
    total-sent="1024",total-size="9880"}
    +download,{section=".text",section-sent="1536",section-size="6668",
    total-sent="1536",total-size="9880"}
    +download,{section=".text",section-sent="2048",section-size="6668",
    total-sent="2048",total-size="9880"}
    +download,{section=".text",section-sent="2560",section-size="6668",
    total-sent="2560",total-size="9880"}
    +download,{section=".text",section-sent="3072",section-size="6668",
    total-sent="3072",total-size="9880"}
    +download,{section=".text",section-sent="3584",section-size="6668",
    total-sent="3584",total-size="9880"}
    +download,{section=".text",section-sent="4096",section-size="6668",
    total-sent="4096",total-size="9880"}
    +download,{section=".text",section-sent="4608",section-size="6668",
    total-sent="4608",total-size="9880"}
    +download,{section=".text",section-sent="5120",section-size="6668",
    total-sent="5120",total-size="9880"}
    +download,{section=".text",section-sent="5632",section-size="6668",
    total-sent="5632",total-size="9880"}
    +download,{section=".text",section-sent="6144",section-size="6668",
    total-sent="6144",total-size="9880"}
    +download,{section=".text",section-sent="6656",section-size="6668",
    total-sent="6656",total-size="9880"}
    +download,{section=".init",section-size="28",total-size="9880"}
    +download,{section=".fini",section-size="28",total-size="9880"}
    +download,{section=".data",section-size="3156",total-size="9880"}
    +download,{section=".data",section-sent="512",section-size="3156",
    total-sent="7236",total-size="9880"}
    +download,{section=".data",section-sent="1024",section-size="3156",
    total-sent="7748",total-size="9880"}
    +download,{section=".data",section-sent="1536",section-size="3156",
    total-sent="8260",total-size="9880"}
    +download,{section=".data",section-sent="2048",section-size="3156",
    total-sent="8772",total-size="9880"}
    +download,{section=".data",section-sent="2560",section-size="3156",
    total-sent="9284",total-size="9880"}
    +download,{section=".data",section-sent="3072",section-size="3156",
    total-sent="9796",total-size="9880"}
    ^done,address="0x10004",load-size="9880",transfer-rate="6586",
    write-rate="429"
    (gdb)

### The `-target-exec-status` Command

#### Synopsis

     -target-exec-status

Provide information on the state of the target (whether it is running or not, for instance).

#### GDB Command

There's no equivalent GDB command.

#### Example

N.A.

### The `-target-list-available-targets` Command

#### Synopsis

     -target-list-available-targets

List the possible targets to connect to.

#### GDB Command

The corresponding GDB command is ``help target'`.

#### Example

N.A.

### The `-target-list-current-targets` Command

#### Synopsis

     -target-list-current-targets

Describe the current target.

#### GDB Command

The corresponding information is printed by ``info file'` (among other things).

#### Example

N.A.

### The `-target-list-parameters` Command

#### Synopsis

     -target-list-parameters

#### GDB Command

No equivalent.

#### Example

N.A.

### The `-target-select` Command

#### Synopsis

     -target-select type parameters ...

Connect GDB to the remote target. This command takes two args:

``type'`
  The type of target, for instance ``async'`, ``remote'`, etc.
``parameters'`
  Device names, host names and the like. See section Commands for Managing Targets, for more details.

The output is a connection notification, followed by the address at which the target program is, in the following form:

    ^connected,addr="address",func="function name",
      args=[arg list]

#### GDB Command

The corresponding GDB command is ``target'`.

#### Example

    (gdb)
    -target-select async /dev/ttya
    ^connected,addr="0xfe00a300",func="??",args=[]
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.18 GDB/MI File Transfer Commands

### The `-target-file-put` Command

#### Synopsis

     -target-file-put hostfile targetfile

Copy file hostfile from the host system (the machine running GDB) to targetfile on the target system.

#### GDB Command

The corresponding GDB command is ``remote put'`.

#### Example

    (gdb)
    -target-file-put localfile remotefile
    ^done
    (gdb)

### The `-target-file-put` Command

#### Synopsis

     -target-file-get targetfile hostfile

Copy file targetfile from the target system to hostfile on the host system.

#### GDB Command

The corresponding GDB command is ``remote get'`.

#### Example

    (gdb)
    -target-file-get remotefile localfile
    ^done
    (gdb)

### The `-target-file-delete` Command

#### Synopsis

     -target-file-delete targetfile

Delete targetfile from the target system.

#### GDB Command

The corresponding GDB command is ``remote delete'`.

#### Example

    (gdb)
    -target-file-delete remotefile
    ^done
    (gdb)

[ < ] | [ > ] |  | [ << ] | [ Up ] | [ >> ] |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

## 24.19 Miscellaneous GDB/MI Commands

### The `-gdb-exit` Command

#### Synopsis

     -gdb-exit

Exit GDB immediately.

#### GDB Command

Approximately corresponds to ``quit'`.

#### Example

    (gdb)
    -gdb-exit
    ^exit

### The `-exec-abort` Command

#### Synopsis

     -exec-abort

Kill the inferior running program.

#### GDB Command

The corresponding GDB command is ``kill'`.

#### Example

N.A.

### The `-gdb-set` Command

#### Synopsis

     -gdb-set

Set an internal GDB variable.

#### GDB Command

The corresponding GDB command is ``set'`.

#### Example

    (gdb)
    -gdb-set $foo=3
    ^done
    (gdb)

### The `-gdb-show` Command

#### Synopsis

     -gdb-show

Show the current value of a GDB variable.

#### GDB Command

The corresponding GDB command is ``show'`.

#### Example

    (gdb)
    -gdb-show annotate
    ^done,value="0"
    (gdb)

### The `-gdb-version` Command

#### Synopsis

     -gdb-version

Show version information for GDB. Used mostly in testing.

#### GDB Command

The GDB equivalent is ``show version'`. GDB by default shows this information when you start an interactive session.

#### Example

    (gdb)
    -gdb-version
    ~GNU gdb 5.2.1
    ~Copyright 2000 Free Software Foundation, Inc.
    ~GDB is free software, covered by the GNU General Public License, and
    ~you are welcome to change it and/or distribute copies of it under
    ~ certain conditions.
    ~Type "show copying" to see the conditions.
    ~There is absolutely no warranty for GDB.  Type "show warranty" for
    ~ details.
    ~This GDB was configured as
     "--host=sparc-sun-solaris2.5.1 --target=ppc-eabi".
    ^done
    (gdb)

### The `-list-features` Command

Returns a list of particular features of the MI protocol that this version of gdb implements. A feature can be a command, or a new field in an output of some command, or even an important bugfix. While a frontend can sometimes detect presence of a feature at runtime, it is easier to perform detection at debugger startup.

The command returns a list of strings, with each string naming an available feature. Each returned string is just a name, it does not have any internal structure. The list of possible feature names is given below.

Example output:

    (gdb) -list-features
    ^done,result=["feature1","feature2"]

The current list of features is:

- ``frozen-varobjs'`---indicates presence of the `-var-set-frozen` command, as well as possible presense of the `frozen` field in the output of `-varobj-create`.
- ``pending-breakpoints'`---indicates presence of the `-f` option to the `-break-insert` command.

### The `-interpreter-exec` Command

### Synopsis

    -interpreter-exec interpreter command

Execute the specified command in the given interpreter.

### GDB Command

The corresponding GDB command is ``interpreter-exec'`.

### Example

    (gdb)
    -interpreter-exec console "break main"
    &"During symbol reading, couldn't parse type; debugger out of date?.\n"
    &"During symbol reading, bad structure-type format.\n"
    ~"Breakpoint 1 at 0x8074fc6: file ../../src/gdb/main.c, line 743.\n"
    ^done
    (gdb)

### The `-inferior-tty-set` Command

### Synopsis

    -inferior-tty-set /dev/pts/1

Set terminal for future runs of the program being debugged.

### GDB Command

The corresponding GDB command is ``set inferior-tty'` /dev/pts/1.

### Example

    (gdb)
    -inferior-tty-set /dev/pts/1
    ^done
    (gdb)

### The `-inferior-tty-show` Command

### Synopsis

    -inferior-tty-show

Show terminal for future runs of program being debugged.

### GDB Command

The corresponding GDB command is ``show inferior-tty'`.

### Example

    (gdb)
    -inferior-tty-set /dev/pts/1
    ^done
    (gdb)
    -inferior-tty-show
    ^done,inferior_tty_terminal="/dev/pts/1"
    (gdb)

### The `-enable-timings` Command

### Synopsis

    -enable-timings [yes | no]

Toggle the printing of the wallclock, user and system times for an MI command as a field in its output. This command is to help frontend developers optimize the performance of their code. No argument is equivalent to ``yes'`.

### GDB Command

No equivalent.

### Example

    (gdb)
    -enable-timings
    ^done
    (gdb)
    -break-insert main
    ^done,bkpt={number="1",type="breakpoint",disp="keep",enabled="y",
    addr="0x080484ed",func="main",file="myprog.c",
    fullname="/home/nickrob/myprog.c",line="73",times="0"},
    time={wallclock="0.05185",user="0.00800",system="0.00000"}
    (gdb)
    -enable-timings no
    ^done
    (gdb)
    -exec-run
    ^running
    (gdb)
    *stopped,reason="breakpoint-hit",bkptno="1",thread-id="0",
    frame={addr="0x080484ed",func="main",args=[{name="argc",value="1"},
    {name="argv",value="0xbfb60364"}],file="myprog.c",
    fullname="/home/nickrob/myprog.c",line="73"}
    (gdb)

[ << ] | [ >> ] |  |  |  |  |  | [Top] | [Contents] | [Index] | [ ? ]

This document was generated by GDB Administrator on March, 27 2008 using texi2html